CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
       MHZ      = 80
       UpDate   = 2_500
       NoGlitch = 3_000
       _1uS     = 1_000_000 
VAR
'Long ServoPinMask
'Long WaveLength
Long ServoOutput[8]

OBJ
 
PUB Start
  'ServoOutPut[0] :=  80_000     '1.0mS
  'ServoOutPut[1] :=  80_000     '1.0mS
  'ServoOutPut[2] :=  80_000     '1.0ms
  'ServoOutPut[3] :=  80_000     '1.0ms
  'ServoOutPut[4] :=  80_000     '2.0ms
  'ServoOutPut[5] :=  80_000     '1.75mS
  'ServoOutPut[6] :=  80_000     '1.5mS
  'ServoOutPut[7] :=  80_000     '1.25ms
  cognew(@ServoOut, @ServoOutput)'Launch new cog
Pub Set(ServoIndex,Width)
    ServoOutput[ServoIndex] := constant(80000000 /1_000_000) * Width                'calculate # of clocks for a specific Pulse Width    
DAT
        ORG 0
ServoOut
        mov           Address, PAR
        'rdlong Servo_Pin_Mask, Address
        mov              DIRA, Servo_Pin_Mask
        'add           Address, #4
        'rdlong    Wave_Length, Address
Sync
        mov              Temp, cnt
        mov          WaveTemp, Wave_Length
        add          WaveTemp, cnt        wc
if_c    jmp #Sync

LoadServoWidth
        'add        Address, #4
        rdlong ServoWidth1, Address
        add    ServoWidth1, Temp
        add        Address, #4
        rdlong ServoWidth2, Address
        add    ServoWidth2, Temp
        add        Address, #4
        rdlong ServoWidth3, Address
        add    ServoWidth3, Temp
        add        Address, #4
        rdlong ServoWidth4, Address
        add    ServoWidth4, Temp
        add        Address, #4
        rdlong ServoWidth5, Address
        add    ServoWidth5, Temp
        add        Address, #4
        rdlong ServoWidth6, Address
        add    ServoWidth6, Temp
        add        Address, #4
        rdlong ServoWidth7, Address
        add    ServoWidth7, Temp
        add        Address, #4
        rdlong ServoWidth8, Address  
        add    ServoWidth8, Temp
        sub        Address, #28

OutPutLoop
        cmpsub  ServoWidth1, cnt        nr,wc     
        muxc      ServoByte, ServoOut1             
        cmpsub  ServoWidth2, cnt        nr,wc     
        muxc      ServoByte, ServoOut2
        cmpsub  ServoWidth3, cnt        nr,wc     
        muxc      ServoByte, ServoOut3
        cmpsub  ServoWidth4, cnt        nr,wc     
        muxc      ServoByte, ServoOut4
        cmpsub  ServoWidth5, cnt        nr,wc     
        muxc      ServoByte, ServoOut5
        cmpsub  ServoWidth6, cnt        nr,wc     
        muxc      ServoByte, ServoOut6
        cmpsub  ServoWidth7, cnt        nr,wc     
        muxc      ServoByte, ServoOut7
        cmpsub  ServoWidth8, cnt        nr,wc     
        muxc      ServoByte, ServoOut8
        mov            OUTA, ServoByte
        cmp        WaveTemp, cnt        nr,wc
if_NC   jmp #OutPutLoop                                     
        jmp #Sync
        
Address        Long %0000_0000_0000_0000_0000_0000_0000_0000
Servo_Pin_Mask Long %0000_0000_0000_0000_1111_1111_0000_0000
Wave_Length    Long 200_000     '400hz
        
ServoOut1      Long %0000_0000_0000_0000_1000_0000_0000_0000
ServoOut2      Long %0000_0000_0000_0000_0100_0000_0000_0000
ServoOut3      Long %0000_0000_0000_0000_0010_0000_0000_0000
ServoOut4      Long %0000_0000_0000_0000_0001_0000_0000_0000
ServoOut5      Long %0000_0000_0000_0000_0000_1000_0000_0000
ServoOut6      Long %0000_0000_0000_0000_0000_0100_0000_0000
ServoOut7      Long %0000_0000_0000_0000_0000_0010_0000_0000
ServoOut8      Long %0000_0000_0000_0000_0000_0001_0000_0000

ServoByte      Long %0000_0000_0000_0000_0000_0000_0000_0000

ServoWidth1    Long %0000_0000_0000_0000_0000_0000_0000_0000 
ServoWidth2    Long %0000_0000_0000_0000_0000_0000_0000_0000
ServoWidth3    Long %0000_0000_0000_0000_0000_0000_0000_0000
ServoWidth4    Long %0000_0000_0000_0000_0000_0000_0000_0000
ServoWidth5    Long %0000_0000_0000_0000_0000_0000_0000_0000
ServoWidth6    Long %0000_0000_0000_0000_0000_0000_0000_0000
ServoWidth7    Long %0000_0000_0000_0000_0000_0000_0000_0000
ServoWidth8    Long %0000_0000_0000_0000_0000_0000_0000_0000

Temp           Long %0000_0000_0000_0000_0000_0000_0000_0000         
WaveTemp       Long %0000_0000_0000_0000_0000_0000_0000_0000
Fit  80
'.000_000_012_5nS per clock cycle
'1_600_000 clock cycles = 20mS or 50hz
'200_000 clock cycles = 2.5mS or 400hz